unit Chat;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    SendButton: TButton;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    CloseButton: TButton;
    Memo: TMemo;
    Chatroom: TLabel;
    Label4: TLabel;
    Client_Button: TButton;
    Connections: TListBox;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    Button3: TButton;
    Button4: TButton;
    Timer2: TTimer;
    Timer3: TTimer;
    Timer4: TTimer;
    Timer5: TTimer;
    Timer6: TTimer;
    Timer7: TTimer;
    Timer8: TTimer;
    Button5: TButton;
    Label3: TLabel;
    procedure FormClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button5Click(Sender: TObject);
    procedure Timer8Timer(Sender: TObject);
    procedure Timer7Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer6Timer(Sender: TObject);
    procedure Timer5Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ServerSendButtonClick(Sender: TObject);
    procedure ServerClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerClientDisConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure CloseButtonClick(Sender: TObject);
    procedure ClientSendButtonClick(Sender: TObject);
    procedure ClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Server_ButtonClick(Sender: TObject);
    procedure Client_ButtonClick(Sender: TObject);
  private
    count: integer;
    ClientSocket: TClientSocket;
    ServerSocket: TServerSocket;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ServerSendButtonClick(Sender: TObject);
var i: integer;
    s: String;
begin
  s:='Server: '+Edit1.Text;
  Edit1.Text:='';
  Memo.Lines.Add(s);
  for i:=0 to count-1 do
    ServerSocket.Socket.Connections[i].SendText(s);
end;

procedure TForm1.ClientSendButtonClick(Sender: TObject);
begin
  ClientSocket.Socket.SendText(Edit1.Text);
  Edit1.Text:='';
end;

procedure TForm1.ClientError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  ErrorCode:=0;
  Client_Button.Enabled:=true;
  SendButton.Enabled:=false;
  Edit2.Enabled:=true;
  Edit3.Enabled:=true;
  Edit2.SetFocus;
  raise exception.Create(' Leider konnte keine Verbindung zum Server hergestellt werden. '+#13#10+' Entweder ist die IP oder der Port falsch! ');
end;

procedure TForm1.ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
var s: String;
begin
  //Beim Connect wird der Teilnehmer angezeigt
  s:=Socket.RemoteHost+' ('+Socket.RemoteAddress+')';
  Connections.Items.Add(s);
  Beep;
end;

procedure TForm1.ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  Connections.Items.Delete(0);
  Socket.Disconnect(0);
  Beep;
end;

procedure TForm1.ClientRead(Sender: TObject; Socket: TCustomWinSocket);
begin
  //Der Text wird gelesen und einem MemoFeld hinzugefgt
  Memo.Lines.Add(Socket.ReceiveText);
end;

procedure TForm1.ServerClientConnect(Sender: TObject; Socket: TCustomWinSocket);
var s: String;
begin
  // bei neuem Connect wird count hochgezhlt!!
  inc(count);
  s:=Socket.RemoteHost+' ('+Socket.RemoteAddress+')';
  Connections.Items.Add(s);
  Beep;
end;

procedure TForm1.ServerClientDisConnect(Sender: TObject; Socket: TCustomWinSocket);
var s: String;
    i: integer;
begin
  s:=Socket.RemoteHost+' ('+Socket.RemoteAddress+')';
  i:=-1;
  repeat
    inc(i);
  until (s=Connections.Items[i]) or (i>count);
  Connections.Items.Delete(i); // RemoteHost aus der Liste lschen
  dec(count);
  Socket.Disconnect(count);
  Beep;
end;

procedure TForm1.ServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
var s: string;
    i: integer;
begin
  //Der Text wird gelesen und einem MemoFeld hinzugefgt
  s:=Socket.RemoteAddress+': '+Socket.ReceiveText;
  Memo.Lines.Add(s);
  for i:=0 to count-1 do
    Serversocket.Socket.Connections[i].SendText(s);
end;

procedure TForm1.CloseButtonClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  count:=0;
end;

procedure TForm1.Server_ButtonClick(Sender: TObject);
var s: String;
begin
  //CloseButton wird deaktiviert
  CloseButton.Enabled:=true;
  //Client_Button wird deaktiviert
  Client_Button.Enabled:=false;
  s:=Edit2.Text;
  Edit2.Text:='verwende IP der Netzwerkkarte';
  Edit2.Enabled:=false;
  Form1.Caption:='Chat - Server';
  //Server wird initialisiert
  ServerSocket:=TServerSocket.Create(Form1);
  //Den Socket-Ereignissen Prozeduren zuweisen
  ServerSocket.OnClientRead := ServerClientRead;
  ServerSocket.OnClientConnect := ServerClientConnect;
  ServerSocket.OnClientDisconnect := ServerClientDisConnect;
  //Dem Server wird ein Port zugewiesen
  ServerSocket.Port:=StrToInt(Edit3.Text);
  //"SendButton" wird die "OnClick"-Methode des Servers zugewiesen;
  SendButton.OnClick:=ServerSendButtonClick;
  Edit2.Enabled:=false;
  Edit3.Enabled:=false;
  SendButton.Enabled:=true;
  CloseButton.Enabled:=true;
  Edit1.SetFocus;
  //Server wird gestartet
  try
    ServerSocket.Open;
  except
    Edit2.Enabled:=true;
    Edit2.Text:=s;
    Edit3.Enabled:=true;
    SendButton.Enabled:=false;
    CloseButton.Enabled:=false;
    Client_Button.Enabled:=true;
    Edit3.SetFocus;
    raise exception.Create(' Leider wurde dieser Port schon verwendet!'+#13#10+' Whle einen anderern!');
  end;
end;

procedure TForm1.Client_ButtonClick(Sender: TObject);
begin
  Client_Button.Enabled:=false;
  //Client wird initialisiert
  ClientSocket:= TClientSocket.Create(Form1);
  //Dem Ereignis die Prozedur zuweisen
  ClientSocket.OnRead := ClientRead;
  ClientSocket.OnConnect := ClientConnect;
  ClientSocket.OnDisconnect:= ClientDisconnect;
  ClientSocket.OnError := ClientError; //TSocketErrorEvent
  //Dem Client wird einen Port zugewiesen
  ClientSocket.Port:=StrToInt(edit3.text);
  //Client bekommt einen Host zugewiesen
  ClientSocket.Host:=Edit2.text;
  //Client wird gestartet
  ClientSocket.Open;
  //IP-Editfeld wird deaktiviert
  Edit2.Enabled:=false;
  //Port-Editfeld wird deaktiviert
  Edit3.Enabled:=false;
  SendButton.Enabled:=true;
  CloseButton.Enabled:=true;
  //"SendButton" wird die "OnClick"-Methode des Clients zugewiesen;
  SendButton.OnClick:=ClientSendButtonClick;
  Edit1.SetFocus;
  Button1.Enabled:=true;
  Button2.Enabled:=true;
  Button3.Enabled:=true;
  Button4.Enabled:=true;
  Button5.Enabled:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Timer1.Enabled:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Timer5.Enabled:=true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
ClientSocket.Socket.SendText('setport 8.1');
Timer2.Enabled:=true;
Timer1.Enabled:=false;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
ClientSocket.Socket.SendText('setport 8.0');
Timer2.Enabled:=false;
end;

procedure TForm1.Timer4Timer(Sender: TObject);
begin
ClientSocket.Socket.SendText('setport 6.1');
ClientSocket.Socket.SendText('setport 7.1');
Timer3.Enabled:=true;
Timer4.Enabled:=false;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
ClientSocket.Socket.SendText('setport 7.0');
ClientSocket.Socket.SendText('setport 6.0');
Timer3.Enabled:=false;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
Timer4.Enabled:=true;
end;

procedure TForm1.Timer5Timer(Sender: TObject);
begin
ClientSocket.Socket.SendText('setport 6.1');
ClientSocket.Socket.SendText('setport 8.1');
Timer6.Enabled:=true;
Timer5.Enabled:=false;
end;

procedure TForm1.Timer6Timer(Sender: TObject);
begin
ClientSocket.Socket.SendText('setport 6.0');
ClientSocket.Socket.SendText('setport 8.0');
Timer6.Enabled:=false;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Timer7.Enabled:=true;
end;

procedure TForm1.Timer7Timer(Sender: TObject);
begin
ClientSocket.Socket.SendText('setport 7.1');
Timer8.Enabled:=true;
Timer7.Enabled:=false;
end;

procedure TForm1.Timer8Timer(Sender: TObject);
begin
ClientSocket.Socket.SendText('setport 7.0');
Timer8.Enabled:=false;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
Button1.Enabled:=false;
Button2.Enabled:=false;
Button3.Enabled:=false;
Button4.Enabled:=false;
SendButton.Enabled:=false;
CloseButton.Enabled:=false;
Memo.Enabled:=false;
Edit1.Enabled:=false;
Edit2.Enabled:=false;
Edit3.Enabled:=false;
Connections.Enabled:=false;
Button5.Enabled:=false;
Label3.Visible:=true;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_UP) then
    Timer1.Enabled:=true;
    Button1.Enabled:=false;
    Button2.Enabled:=false;
    Button3.Enabled:=false;
    Button4.Enabled:=false;
    SendButton.Enabled:=false;
    CloseButton.Enabled:=false;
    Memo.Enabled:=false;
    Edit1.Enabled:=false;
    Edit2.Enabled:=false;
    Edit3.Enabled:=false;
    Connections.Enabled:=false;
    Button5.Enabled:=false;
    Label3.Visible:=true;
  if (Key = VK_DOWN) then
    Timer5.Enabled:=true;
    Button1.Enabled:=false;
    Button2.Enabled:=false;
    Button3.Enabled:=false;
    Button4.Enabled:=false;
    SendButton.Enabled:=false;
    CloseButton.Enabled:=false;
    Memo.Enabled:=false;
    Edit1.Enabled:=false;
    Edit2.Enabled:=false;
    Edit3.Enabled:=false;
    Connections.Enabled:=false;
    Button5.Enabled:=false;
  if (Key = VK_LEFT) then
    Timer7.Enabled:=true;
    Button1.Enabled:=false;
    Button2.Enabled:=false;
    Button3.Enabled:=false;
    Button4.Enabled:=false;
    SendButton.Enabled:=false;
    CloseButton.Enabled:=false;
    Memo.Enabled:=false;
    Edit1.Enabled:=false;
    Edit2.Enabled:=false;
    Edit3.Enabled:=false;
    Connections.Enabled:=false;
    Button5.Enabled:=false;
  if (Key = VK_RIGHT) then
    Timer4.Enabled:=true;
    Button1.Enabled:=false;
    Button2.Enabled:=false;
    Button3.Enabled:=false;
    Button4.Enabled:=false;
    SendButton.Enabled:=false;
    CloseButton.Enabled:=false;
    Memo.Enabled:=false;
    Edit1.Enabled:=false;
    Edit2.Enabled:=false;
    Edit3.Enabled:=false;
    Connections.Enabled:=false;
    Button5.Enabled:=false;
end;

procedure TForm1.FormClick(Sender: TObject);
begin
    Label3.Visible:=false;
    Button1.Enabled:=true;
    Button2.Enabled:=true;
    Button3.Enabled:=true;
    Button4.Enabled:=true;
    SendButton.Enabled:=true;
    CloseButton.Enabled:=true;
    Memo.Enabled:=true;
    Edit1.Enabled:=true;
    Edit2.Enabled:=true;
    Edit3.Enabled:=true;
    Connections.Enabled:=true;
    Button5.Enabled:=true;
end;

end.
